*************************************************************************
*                                                                       *
*  RwabsMon.  Written by  David Small.  		               	*
*   Copyright 1987, David Small.					*
* Ripped off from the MouseTrap, which was written by Dan Moore and me. *
*   									*
* RwabsMon monitors all rwabs activity, giving a cute little display	*
* onscreen. It's handy for some applications. This is written to be a   *
* TSR, for yer AUTO folder. It sure ain't long.				*
*									*
* The usual revision history:						*
*									*
* 1.0: Just steals trap 13 (stolen from moustrap code, really)		*
* 1.1: Made msg on rwabs.						*
* 1.2: Added my char driver, fontinit, and I/O subroutines		*
* 1.3 Adding visual map, I think on left side. (Why not?)		*
* 1.4 Deleted visual map, because it doesn't show anything worthwhile.  *
* 1.5 Cleaned up, commented. Added sign-in page.                        *
*************************************************************************
* 
************************** Turn on local font driver *************

* Now seems like a good time to start up the font/character generator
* driver, and do the inits that it craves.
*
*
* Note: initfont will not return if we are in low res mode.
* I *really* shold handle it up here, but, big buzz.
*
	jsr	initfont
*
************************* Generate Welcome Message ******************
*
*	move.l 	#mwelcome,-(a7)	* ptr to message, on stack
*	move.w	#9,-(a7)	* gemdos write null terminated string
*	trap	#1		* write it out
*	adda.l	#6,a7		* fix stack 
*
* Just for fun, indicate where we are resident in RAM.
*
	lea	mwelcome,a2	* point debugger at it

* upper left
	move.w	#0,atscrnx
	move.w	#112+64,atscrny

	jsr	putstring	* output the welcome message
* Resident location calculation stuff

	lea	mresident,a2
	jsr	putstring
        move.l   4(A7),D3           ; get the start of the basepage
	jsr	putlong		* output it
*
	lea	mr2,a2
	jsr	putstring
*
        movea.l   4(A7),A0           ; get the start of the basepage
	move.l	A0,D0			; save for math
        add.l    $c(A0), D3          ; add the length of the text segment
*					* we would add data & bss but they = 0
        add.l     #256, D3            ; add length of  the base page (always
*									$100)
* And spit it out...
*
	jsr	putlong
* Finish up display..
	lea	mrcrlf,a2
	jsr	putstring
* This is the pointer to the BIOS register save area.  It is guaranteed to
* stay the same in future TOS versions.
*
SAVEPTR    equ      $04a2     

***************** Get address of trap 13 jump table ********

* We need the address of the TRAP 13 jump table.  The easy way to get it is
* to execute an illegal XBIOS command (func # > 39).  On exit A0 will point
* to the table start + 2.  (How convenient.)
*
goforit:  move.w    #127, -(A7)         ; allow for new function #'s
          trap      #13                 ; do the trap
          adda.l    #2, A7              ; clear the stack
          suba.l    #2, A0             ; get the table start
          move.l    A0, trap13table

* "trap13table" now points to the start of the trap 13 table.
*
************************** Steal away trap 13 to us ******************

* now we need to install our trap 13 handler in place of the system one.
* the trap 13 vector is at $b8, which is in protected memory.  Must be in
* super mode to change it.
*
* So, we do it with supexec, with a typically Dan Moore "C"'ish hack.
* 
* Loads "mytrap" into exception vector for trap 13.
*
          pea       setmytrap           ; the address of the routine to run
          move.w    #38, -(A7)          ; supexec
          trap      #14  
          adda.l    #6, A7

* As of now  all TRAP #13 calls are being handled by our code.
*
*
*
************************* Terminate & Stay Resident **************
*
* Now, we need to terminate and stay resident, so the trap 13 handler
* doesn't disappear.

term:	nop
*
* Apparently we pass, on the stack, the # of bytes to keep.
*
          movea.l   4(A7), A0           ; get the start of the basepage
*
          move.l    $c(A0), D0          ; the length of the text segment
          add.l     #256, D0            ; plus the base page

          clr.l     -(A7)               ; no error (we think)
          move.l    D0,-(a7)            ; memory to keep
          move.w    #$31,-(a7)          ; ptermres
          trap      #1                  ; whoopee -- we're gone.
*
trap13table:	.dc.l	0		* ptr to trap 13 table
*
saved0:	.dc.l	0
savea0:	.dc.l	0
****************************************************************
* Welcome wagon messages *
	.even
mwelcome .dc.b	cr,lf
	.dc.b	'*******************************************',cr,lf
	.dc.b	'*					   *',cr,lf
	.dc.b	'*           RwabsMon Installed.           *',cr,lf
	.dc.b	'* Copyright 1987 Dan Moore & David Small. *',cr,lf,00

	.even

mresident .dc.b '* Resident in RAM locations:              *',cr,lf
	.dc.b	'*  Start: $',00
*			    12345678!	
	.even
*			            !
mr2:	.dc.b		            ' end: $',00
*					    12345678!
	.even
*						    !
mrcrlf:	.dc.b					   '.       *',cr,lf
	.dc.b	'*					   *',cr,lf
	.dc.b	'*******************************************',cr,lf,00


	.even

*************** install mytrap13 into exception table **********************
*
* Subroutine:
* Install mytrap13as the new system TRAP 13 handler. This is
* run by supexec.
*
setmytrap:
          lea       mytrap13,A0		; get addr of our handler into a0
	  move.l    a0,$b4		; trap #13. ($b8 is trap 14).
          rts                           ; short ain't it.

*************** trap 13 handler that replaces sys handler ***********
*
* This is the new TRAP 13 handler.  It does almost the exact same thing as
* the system TRAP handler, but it also checks for initmous commands. 
*
mytrap13:  
	move	SR,savesr			; no interruptions for a bit
	or	#$0700,SR			; IPL = 7

* Straight from Atari's trap 13 (and 14) handler.

	     movea.l   trap13table, A0     ; the system trap jump table
	       movea.l   SAVEPTR, A1         ; a1: register save area.
               move.w    (A7)+, D0           ; save SR from trap into d0
               move.w    D0, -(A1)           ; save SR in SAVEPTR
               move.l    (A7)+, -(A1)        ; save return address in SAVEPTR
               movem.l   D3-D7/A3-A7, -(A1)  ; save the registers in SAVEPTR
               move.l    A1, SAVEPTR	     ; save A1...like a LINK
               
* Check whether the BIOS call was from user or super mode. This tells
* us which stack has the parameters stacked up on it, which we need to
* then look at.

               btst      #13, D0		; bit 13 of SR at trap
               bne       supermode           ; all is fine and dandy = ssp
               move.l    USP, A7             ; nope, get user stack
supermode:	nop				; okay, stack is ready
* First thing on (a7)+ is the function #.word ...:
               move.w    (A7)+, D0           ;get the function number into d0.w
* 1st word of trap table must be maximum # of traps
*
               cmp.w     (A0)+, D0           ; out of range?
               bge       done                ; yes, done
* Well, it's tolerably in range, so...
* Check if _rwabs function. If not, pass it to the Atari handler.
               cmpi.w    #4, D0			; #4.
               bne       doit                ; nope, just treat it normally
*
* Yes it is. Do the display.  We can't really use the stack, because
* I'm scared to mess it up, so let's just save our registers
* locally.
*
* Now, re-enable interrupts we so rudely closed off.
		move	savesr,SR
*
	movem.l	d0-d7/a0-a7,savethem	* save registers
*
* Assuming rwabs, we have on stack: (starting at (a7),
*  bearing in mind we just popped off the function.word a moment ago...
*
*         -2(a7)  .w  function word just popped (careful about using it tho)
*            (a7) .w  rwflag 0:rd 1:wt 2:rd,no media chg 3: wt,no media chg
*           2(a7) .l  buffer
*           6(a7) .w  number: # of 512 byte sectors to transfer
*           8(a7) .w  recno: starting logical # sector # to begin transfer
*          $a(a7) .w  dev: device # (0=a,1=b,2=c, etc)
*
* Order to output them:
*        device.char   r/w.char starting sec.word # of secs.word  buffer #.long
* 
* Note: this format will change as I adjust it aesthetically.
*
*         A:  RD SEC:0100 #:SEC BUFF:0007a700 
*
* Of course, the tricky part is to not mangle the stack, so we'd best move
* it somewhere save for a bit.
*
*   First off, though, stash the parameters locally. Typical sloppy coding.
*
	move.w	(a7),xrwflag
	move.l	2(a7),xbuffer
	move.w	6(a7),xnumber
	move.w	8(a7),xrecno
	move.w	$a(a7),xdev
*
* Now fidget stack around to a nice, handy, SAFE local area.
*
		movea.l	#tempa7,a7	* keep it somewhere safe
*
* Reset screen X,Y. Play with this until it's cool.
*
	move.w	#45,atscrnx		* tweak me 
	move.w	#1,atscrny		* top of screen
*
* Generate Device # - ABCDEFG...
*
	clr.l	d0
	move.w	xdev,d0			* get 0,1,2,3...
	add.w	#$41,d0			* change to "A,B,C,D,.." (in ASCII)
	jsr	aputc			* output it
	jsr	putcolon		* and a colon
*
*         A:  RD SEC:0100 #:SEC BUFF:0007a700 
*
* Generate RD or WT, and SEC: header message
*
	move.w	xrwflag,d0
	andi.w	#1,d0			* get to low bit. 1/3=wt, 0/2=rd
	beq	itsread
	lea	wtmsg,a2		* point at write message
	bra	dosec

	.even
* It seems that an abbreviated version is in order. Fine.

rdmsg:	.dc.b 	' RD: ',00
	.even
wtmsg:	.dc.b	' WT: ',00
	.even
numsecs: .dc.b	' #: ',00
	.even
buffmsg: .dc.b	' BUF: ',00
	.even

itsread: lea	rdmsg,a2
dosec:	jsr	putstring		* print whichever one and SEC header
*
*         A:  RD SEC:0100 #:SECS BUFF:0007a700 
*
* Generate logical sector #.word
*
	move.w	 xrecno,d3		* d3 = input word to send
	jsr	putword
*
* generate # of secs message
*
	lea	numsecs,a2		* a2 points at message
	jsr	putstring
*
* generate # of secs.word. Don't we WISH it could be a long, and
* lift that painful restriction on hard disks..
*
	move.w	xnumber,d3		* d3 = input word to send
	jsr	putword
*
* Generate buffer message
*
	lea	buffmsg,a2		* a2 points at message
	jsr	putstring		* dump it out
*
* Generate buffer.long
*
	move.l	xbuffer,d3
	jsr	putlong
*
* Okay, all done. Let's put everything back the way we found it.
*
	movem.l	savethem,d0-d7/a0-a7	* recover registers
	bra	saltmines
*
* Usual thrilling storage. I'm a big believer in putting storage
* next to whatever uses it, as you might have noticed. So much
* for data and code segments. Oh, well.
*
*
xrwflag:	.dc.w	0
xbuffer:	.dc.l	0
xnumber:	.dc.w	0
xrecno:		.dc.w	0
xdev:		.dc.w	0
*
savethem:	.dc.l	0,1,2,3,4,5,6,7
		.dc.l	0,1,2,3,4,5,6,7
*
* And now a local stack area from our sponsor. A page ought to be
* *more* than plenty.
*
		.dc.l	0,1,2,3,4,5,6,7,8,9,$a,$b,$c,$d,$e,$f *16
		.dc.l	0,1,2,3,4,5,6,7,8,9,$a,$b,$c,$d,$e,$f *32
		.dc.l	0,1,2,3,4,5,6,7,8,9,$a,$b,$c,$d,$e,$f *48
		.dc.l	0,1,2,3,4,5,6,7,8,9,$a,$b,$c,$d,$e,$f *64
		.dc.l	0,1,2,3,4,5,6,7,8,9,$a,$b,$c,$d,$e,$f *80
		.dc.l	0,1,2,3,4,5,6,7,8,9,$a,$b,$c,$d,$e,$f *96
		.dc.l	0,1,2,3,4,5,6,7,8,9,$a,$b,$c,$d,$e,$f *112
		.dc.l	0,1,2,3,4,5,6,7,8,9,$a,$b,$c,$d,$e,$f *128 words
* Stacks grow DOWN remember.
*							      * or, 256 bytes
tempa7:		.dc.l	0,1,2,3,4,5,6,7,8,9,$a,$b,$c,$d,$e,$f * leave slop
*
***************
saltmines: nop
********** end of special routine **********
* and back to the salt mines. We'll go do whatever the Atari wanted us to
* do (including, by the way, the RWABS).
*
	nop				* oh, why not
* Standard trap handler code...
* figure out which vector to use
doit:          lsl.w     #2, D0              ; long index of function
               move.l    0(A0, D0.w), D0     ; pointer to function
               movea.l   D0, A0              ; check for negative
               bpl       direct			; Atari's nonsense
               movea.l   (A0), A0            ; indirect reference
direct:        movea.l   #0, A5              ; A5 points to zero page
*
* Now, re-enable interrupts we so rudely closed off.
		move	savesr,SR
*
again:         jsr       (A0)                ; go do it

* clean up and exit. Same as system code.
done:          movea.l   SAVEPTR, A1         ; get the save area into A1
               movem.l   (A1)+, D3-D7/A3-A7	; unstack regs
               move.l    (A1)+, -(A7)        ; get return address
               move.w    (A1)+, -(A7)        ; get SR
               move.l    A1, SAVEPTR		; fixup SAVEPTR
               rte                           ; all done, go home
*						* (get PC & SR off (a7)+  )
*
savesr:	.dc.w	0				* saved SR
*
*-----------------------------------------------------------------------
*
codeend: nop
*
*****************************************************************
*
*                 I/O Support. Dave Small 12/85.
*
* Really, this stuff was done for the Magic Sac monitor. Honest.
* We needed a no-RAM monitor, only registers, which accounts for
* the "somewhat odd" architecture of this. But it works, so why
* rewrite it?
*
*
******************************************************************
*
* Three files:
* 1) Character driver init: sets up various parameters for the char
*    drivers (screen's RAM base, locs of font tables, etc)
* 2) Basic I/O System (basic hexadecimal and string output stuff)
* 3) Character driver (single character "putc" driver)
*
*  These all give us the capability to write chars directly to the screen
* in a reasonable manner, and more importantly, without touching lots
* of important and touchy system stuff (like GEM).
*
* Routines to call:
*
*   Math:
*
*  putlong: d3.l  (outputs a hex long)
*  putword: d3.w  (outputs a hex word)
*  putbyte: d2.b  (outputs a hex byte)
*
*   Char:
*
*  putstring: a2.l (outputs a zero terminated string)
*  putcolon, putspace, putcrlf -- three handy things often needed
*  putc: d0.b     (outputs one character)
*
* And, of course, tweak  
* atscrnx, atscrny: for output location (careful, 200 lines in color,
* 400 in mono).
*
*
****************************** Char driver init ************************
*
* Determine locations of 8x16 and 8x8 system fonts in Atari ROM memory.
*
* Also determines a few miscellaneous flags that our character driver
* needs to operate, screen RAM location, etc.
*
* This needs to be done early in code, so system traps and stuff are ok
* to use.
*
* Note: This zaps lots and lots of registers.
*
initfont: nop
fontinit: nop			* for those of us with a bad memory
*
* Line - "A" trap to give us location of system fonts.
	.dc.b	$a0,00		
*
* a1 = ptr to 3 ptrs, which point to 3 font headers.
* We need second and third. They are 8x8, for color, and 8x16, for mono.
*
zap:	nop
* pick off color..
	movea.l	4(a1),a0	* a0 = ptr to 8 x 8 font header
	movea.l	$4c(a0),a3	* a3 = ptr to actual font data
	move.l	a3,colorfontbase
* pick off mono..
	movea.l	8(a1),a0	* a0 = ptr to 8 x 16 font header
	movea.l	$4c(a0),a3	* a3 = ptr to actual font data
*
	move.l	a3,monofontbase	* pointer to beginning of all fonts

* And, init X and Y locations of where to begin output. This gives
* us a default in case program forgets to do it (helps debug).

	move.w	#100,atscrnx	* x loc on screen
	move.w	#100,atscrny	* y loc on screen.. force scrolling.
*
********************* Determine mono/color flag ***********************
*
* Do "getrez" xbios call to determine screen resolution.
* low res: halt.
* med res: set colorflag = ffff
* high res: set colorflag = 0000.
* The colorflag is used by the actual char driver to select how the
* copying is done.
*
	move.w	#0,colorflag	* zero it to default (mono)
*
	move.w	#4,-(sp)	* function #4: getrez
	trap	#14		* xbios call
	adda.l	#2,a7		* fixup stack
* low res?
	cmpi.b	#0,d0
	beq	lowres
* med res?
	cmpi.b	#1,d0
	beq	medres
* hi res.
	bra	highres

********************
lowres:	nop
* We need to print out a diagnostic and halt.
	move.l 	#mlowres,-(a7)	* ptr to message, on stack
	move.w	#9,-(a7)	* gemdos write null terminated string
	trap	#1		* write it out
	adda.l	#6,a7		* fix stack 
* Wait for a key
	move.w	#2,-(a7)	* console device
	move.w	#2,-(a7)	* conin function
	trap	#13		* do it
	adda.l	#4,a7		* repair stack
* Just exit to GEM. We can't handle the weirdo 4-words-per-16-pixels mode.
	adda.l	#4,a7		* Pop return stack manually.. may not help..
	move.w	#0,-(a7)	* This ought to be just pterm...
	trap	#1		* terminate.
**************************
	.even
mlowres: .dc.b	cr,lf, 'The RwabsMon does not',cr,lf
	.dc.b	'operate in low-res color mode.',cr,lf
	.dc.b	'It is accordingly disabled.',cr,lf
	.dc.b	'Please press a key to continue..',cr,lf,0
	.even
*********************
medres:	nop
	move.w	#$ffff,colorflag	* set it high, I guess
highres:	nop

******************* Determine screen RAM base *******************

pastcolor: nop				* entry from if mono
*
* Now, we need to determine the screen's starting location so we
* can tell the char driver where to output from. Use the xbios
* call, even though we can snarf it off the shifter chip OR get
* it from low RAM.
*
	move.w	#2,-(a7)		* physbase call
	trap	#14			* do the call
	adda.l	#2,a7			* repair stack
	move.l	d0,screenptr		* and save the results (returned
*					* in d0)
*
* Okay, we're all set up. Exit, stage left.
	rts

************************** end initfont***********************************
*
*********************** Basic I/O Subroutines ***************** 
*
* These just provide handy ways of getting hex data and strings
* output; they're stripped down for this application.
* Originally they were written to use no memory, but that's
* changed over time, when we started using Atari's BIOS for I/O. Before
* that, we used the MIDI port for I/O (specially rewired), and honest,
* I used NO memory whatsoever.
*
* I peeled out the getbyte, getword, getlong because RwabsMon never
* ever uses them. But I left the getc as an example, and it is not
* difficult (an afternoon) to cobble them up.
*
* If you'll steal these, you'll never have to kludge up a quick
* "print out a long in hex" routine again.
*
* "Steal from the Best"
*          -- Quote from David Small, START Issue #1 (hint, hint)
*
* Present register map.
*
* d0,a0: getc/putc,itoa,atoi
* d1: counter in putlong
* a1: unused
* d2,a2: getbyte,putbyte
* a2 is also input to putstring
* d3,a3: getlong,putlong
* -----
* d4,d5,d6,d7 are main routine counters
* a4 is usually a pointer at a mem location (display, go, etc)
* a5 is the return address for low level (ll) subroutines
* a6 is the return address for high level (hl) subroutines.
* a7 is stack pointer .. a no-no to use.
* 
***************************************************
cr      equ     $0d
lf      equ     $0a
***************************************************
* findputstring: output a string
putstring       nop
* puts (a2) out until zero byte terminator hi. No conversion.
* input: a2 points to string to output.
* Clobbers a2,(a0,d0 in putc)
*
putsloop        nop
        move.b  (a2)+,d0                * fetch byte, d0 = input for putc
        cmpi.b  #0,d0                   * zero byte terminator?
        bne     ps1                     * nope
	rts
*
ps1:
	jsr	putc			* output another char, reloop
	bra	putsloop

*******************************************************
* findputcolon : Puts a colon on the screen, nice and easy.
putcolon        nop
* put a colon out to the screen. Clobbers (a0,d0 in putc).
        move.b  #':',d0
	jsr	putc
	rts
*******************************************************
* findputspace
putspace
* put a space out to the screen. Clobbers (a0,d0 in putc).
        move.b  #' ',d0
        movea.l a6,a5                   * just transfer hl to ll return
	jsr     putc
	rts

*******************************************************
* findputcr
putcr
* put a c, then lf, out to the screen. Clobbers (a0,d0 in putc).
        move.b  #cr,d0
	jsr	putc
        move.b  #lf,d0
	jsr	putc
	rts
*
*******************************************************
* findputlong
putlong
* put d3.l out.
* input: d3
* clobbers: d3,a3,(d2,a2 in putbyte),(d0,a0 in putc)
* also clobbers: d1 (our private counter)
*
*
        move.l  #4-1,d1                 * counter
plloop
* rotate in first char from left
        rol.l   #8,d3
        move.b  d3,d2                   * get d3 byte into d2 (putbyte input)
        andi.l  #$ff,d2                 * insurance
	jsr	putbyte			* do this one
pl2
        dbf     d1,plloop               * do 3 more, 4 total
	rts
*********************************************************
* findputword
* put d3.w out.
* input: d3
* clobbers: d3,a3,(d2,a2 in putbyte),(d0,a0 in putc)
* also clobbers: d1 (our private counter)
*
*
putword: move.l  #2-1,d1                * counter -- how many bytes to output
	swap	d3			* get word into top half for
*					* the putlong algorithm to work
wplloop:
* rotate in first char from left
        rol.l   #8,d3
        move.b  d3,d2                   * get d3 byte into d2 (putbyte input)
        andi.l  #$ff,d2                 * insurance
	jsr	putbyte			* do this one
        dbf     d1,wplloop               * do 3 more, 4 total
	swap	d3			* recover d3 to what it wuz
	rts
*********************************************************
* findputbyte
putbyte
* dumps d2.b. Clobbers: d2,(d0,a0 in putc)
* Output first nibble..
        ror.l   #4,d2                   * get to high nibble first
        move.b  d2,d0                   * d0 is input to itoa
        andi.l  #$f,d0                  * insurance
	jsr	itoa			* integer to ascii convert
* send byte; d0 is input to putc and output from itoa, so it chains in ok.
	jsr	putc			* send the char
* Get second nibble and output it..
        rol.l   #4,d2                   * back to lower nibble
        move.b  d2,d0                   * into d0 for itoa
        andi.l  #$f,d0                  * insurance
	jsr	itoa			* integer to ascii
* input to putc is in d0. output from itoa was in d0. works.
	jsr	putc			* display/print it.
	rts				* exit
******************************************************
* finditoa
itoa:
* converts d0.nibb to d0.b in ascii. Straight lookup. There's
* more clever ways to do this, but I can never get them right.
*
* clobbers: d0,a0
* input: d0.nibb
* note: d0,a0 also used in getc/putc. But since this calls no one
* it should be okay. Also, it is convenient, since we generally
* call those after calling this or atoi.
*
        andi.l  #$f,d0                  * mask for insurance
        lea     itoatab,a0              * a0 points to table
        adda.l  d0,a0                   * add in index
        move.b  (a0),d0                 * fetch byte into d0
        rts
*
        .even   
*
itoatab
        .dc.b   '0123456789ABCDEFZZ'
*
        .even   
*
*********************************************************
*
*********************************************************
*                                                       *
* All program I/O goes through getc/putc. Change them   *
* to change the destination device (Atari CRT, 68901,   *
* 6850, Mordor..)                                       *
*							*
* This is smarter than you might think, because with	*
* one easy change, or even under program control	*
* (hint, hint) you can redirect, or even copy, things	*
* between I/O devices, like the printer for instance.	*
*                                                       *
*********************************************************
*
* I'll go ahead and leave the input stuff as a standalone.
*
* findgetc : for editor.
*
************************** getc **************************
*
* This is your ultra-low-level get 1 character routine.
* Wire it to whatever device you are getting chars from --
* keyboard direct, console device, MIDI, serial, the Astral Plane, whatever.
*
* input: zilch.
* output: d0.b = character.
*
* Note that it calls putc to echo the character.
*
getc:    nop
* get input char/byte into d0.b.  Clobbers d0,a0.
        bra     congetc		* wired to console getc routine
*
* If yer gonna hook it to something else, you want these:
*
* Devices:
printer equ     $0              * printer device #
console EQU     $2              * bios 13 console device for conin/out/stat
*
* BIOS 13 Trap 1,2,3 Call Types:
constat equ     $1              * bios 13 parameter for input device status
conin   equ     $2              * bios 13 parameter for conin call      
conout  equ     $3              * bios 13 parameter for conout call
*
**************8************* console getc ****************
* findcongetc
congetc nop                     * entry pt
*
* 1) Wait for a character..
*
getcrdy: nop                     * for no-char-yet reloop
*
        move.w  #console,-(a7)  * console call
        move.w  #constat,-(a7)  * bios status of input device call #
*
        jsr     saveregs        * save all regs but a7 around bios call
*
        trap    #13             * do call
        addq.l  #4,a7           * fix stack
* d0.l is 0 if no chars rdy, 0000 ffff if some ready.
        tst.w   d0              * test low word
        beq     getcrdy         * loop, waiting for key to be ready
*
        jsr     restregs        * fix registers
***
* 2) character ready, so input it.
        move.w  #console,-(a7)  * device
        move.w  #conin,-(a7)    * conin call
* Once again, save regs around a BIOS call.
        jsr     saveregs        * save registers but a7&d0  around bios call
        trap    #13
        adda.l  #4,a7           * fix stack
        jsr     restregs        * restore all but a7 and d0
*
        andi.l  #$ff,d0         * mask off IBM stuff in high word
* mask, check, return.
        andi.l  #$7f,d0         * mask off parity bit
* 3) We really should echo the key to the screen..
        bra     putc            * which will rts to return..heh

**************************************************************
* Subroutine:  console input status.
* Exit with d0 = ff if char waiting.
* Else, d0 = 0.
**************************************************************
status: nop
        move.w  #console,-(a7)  * console call
        move.w  #constat,-(a7)  * bios status of input device call #
*
        jsr     saveregs        * save all regs but a7 around bios call
*
        trap    #13             * do call
        addq.l  #4,a7           * fix stack
* d0.l is 0 if no chars rdy, 0000 ffff if some ready.
        jsr     restregs        * restore registers (all but a7 and d0)
*
        rts
******************************************************************

*
****************************** putc ******************************
* Wedge your ultra-low-level 1-character-putter into here. Give it to me
* in the d0.b register. It will not be destroyed. 
*
* putc:
* input: d0.b
*         outputs 1 character to output device.
*
* findputc : for debugger
*
putc    nop
*
	bra	aputc			* direct screen char driver
*
* Or, you can turn on conputc if that's what you want. You may
* also write to the serial port, MIDI, whatever. It's that powerful.
* I hope this gives you SEVERAL really devious ideas. It did me.
*
*        bra     conputc                 * BIOS console putc
*
* put byte to device. Byte in d0.b. Uses d0,a0.
* Note: Must not destroy d0. Getc jumps here to echo input character.
*
* findconputc
conputc: nop
*************************** Console putc (BIOS) *********************
*
* Atari monitor version
        movea.l d0,a0           * save d0 in a0 just in case
*
conout  EQU     $3              * BIOS parameter for conout..
        move.w  d0,-(a7)        * character to display
        move.w  device,-(a7)    * device
        move.w  #conout,-(a7)   * conout bios function
*
        jsr     saveregs        * save registers around bios call
*
        trap    #13             * do the char output function
        addq.l  #6,a7           * fix stack
*
        jsr     restregs        * restore all but a7 & d0
*
        move.l  a0,d0           * recover d0, just in case
* All done. Exit normally.
	rts 
*
* Output redirection flag...default it to the console (BIOS CRT)
*
device  .dc.w   console                 * default to console
*-------------------------------------------------------------------------
* Save and Restore registers around a trap 13.
*
* Does not save or restore d0 or a7, because a7 is the stack,
* and because d0 is what the traps return for status..
*
* of course, this code is only good when the stack is up (but
* a bios call assumes that anyway).
*
saveregs        nop
        move.l  d0,d0bios	* but not restored
        move.l  d1,d1bios
        move.l  d2,d2bios
        move.l  d3,d3bios
        move.l  d4,d4bios
        move.l  d5,d5bios
        move.l  d6,d6bios
        move.l  d7,d7bios
*
        move.l  a0,a0bios
        move.l  a1,a1bios
        move.l  a2,a2bios
        move.l  a3,a3bios
        move.l  a4,a4bios
        move.l  a5,a5bios
        move.l  a6,a6bios
        move.l  a7,a7bios	* but not restored
        rts
********
restregs        nop
* restore all but a7 and d0. Used in bios calls in getc/putc.

*       (skip d0)
        move.l  d1bios,d1
        move.l  d2bios,d2
        move.l  d3bios,d3
        move.l  d4bios,d4
        move.l  d5bios,d5
        move.l  d6bios,d6
        move.l  d7bios,d7
*
        movea.l a0bios,a0
        movea.l a1bios,a1
        movea.l a2bios,a2
        movea.l a3bios,a3
        movea.l a4bios,a4
        movea.l a5bios,a5
        movea.l a6bios,a6
*       (skip a7)
        rts
*****
*
* save locs, used by BIOS calls only in basic i/o (getc,putc):
*
        .even
*
d0bios  dc.l    0
d1bios  dc.l    $d1d1d1d1
d2bios  dc.l    $d2d2d2d2
d3bios  dc.l    $d3d3d3d3
d4bios  dc.l    $d4d4d4d4
d5bios  dc.l    $d5d5d5d5
d6bios  dc.l    $d6d6d6d6
d7bios  dc.l    $d7d7d7d7
a0bios  dc.l    $a0a0a0a0
a1bios  dc.l    $a1a1a1a1
a2bios  dc.l    $a2a2a2a2
a3bios  dc.l    $a3a3a3a3
a4bios  dc.l    $a4a4a4a4
a5bios  dc.l    $a5a5a5a5
a6bios  dc.l    $a6a6a6a6
a7bios  dc.l    $a7a7a7a7
*
        .even

************************************************************
makesuper: nop
* Get in supervisor mode so we can tweak hardware directly. 
        move    sr,d0           * If in super already, kindly do not undo
        andi.w  #$2000,d0       * Mask to super bit of status register
        bne     nowsuper        * no need to change
* Shift to Super via GEMDOS call #$20.
        move.l  #0,-(sp)        * use present USP for SSP
        move.w  #$20,-(sp)      * GEMDOS trap #20
        trap    #1
        adda.l  #6,sp           * fix stack
nowsuper: nop
        rts
*********************************************************
*
******************* Direct Screen Character Driver *************************
*
* By: Dave Small, Copyright 1986, 1987.
*
*
* This routine outputs the character is d0.b to the screen, at the x,y
* coordinates in atscrnx, atscrny. (Must be byte aligned.. I don't try
* THAT hard).
*
* In mono, it uses 8 x 16 font, which looks nice. In color, it uses
* 8 x 8 font, because there's half as many scan lines as in mono, and
* we want to keep the chars (roughly) the same height. It compensates
* as much as it's little heart can for the weird color screen mapping.
*
* It tries it's darndest to change NOTHING -- no registers, no nothing,
* so as to not cause compatibility issues.
*
* Note how it blends in nicely with the character, string, and hex
* output routines that precede it. Can you say, "coincidence?". I didn't
* think you'd want to.
*
* You'd better have called initfont before doing this, lest you crash in
* a big way.
*
* Feed me:
*
* A decent sized A7 stack.
* d0.b: the ASCII character you want outputted to the screen.
* atscrnx, atscrny: Where you'd like the char to end up.
* colorfontbase, monofontbase, colorflag: Just call initfont, it'll do it.
* I will update them appropriately for cr/lf and bump the X one loc
* per character output.
*
*****************************************************************
aputc: nop

* Save all registers -- this will probably use them all.
*
	movem.l	a0-a7/d0-d7,atptrsave * save registers on stack

******
* Special handing needed for CR/LF.
* cr or lf? If so, just update x/y, leave
	cmpi.b	#lf,d0		* lf? Go one line down.
	beq	atdolf
	cmpi.b	#cr,d0		* cr? Return to column one.
	beq	atdocr

	bra	atdochar	* a char. handle it.
*******
* LF. If we haven't hit screen bottom, then just update the stored
* Y coordinate and exit. If we have hit screen bottom, we leave
* Y coordinate alone, and scroll entire screen up a line. This may
* go *poof* in color, haven't really tested it.
*
atdolf: tst.w	colorflag
	bne	colcompare	* use color compare

**** mono compare for bottom of screen:
	cmpi.w	#400-16,atscrny	* y max?
	bcc	scroller	* atscrny > = 384 ... last 2 lines
* Just add to Y position; not at screen bottom yet.
	addi.w	#16,atscrny	* add 1 to y.. (16 scan lines)
	bra	aputbreturn	* processing complete, exit.

**** color compare for bottom of screen:
colcompare:	nop
	cmpi.w	#200-8,atscrny	* y max?
	bcc	scroller	* atscrny in last 2 lines, so scroll it
* Just add to Y; not at screen bottom yet.
	addi.w	#8,atscrny	* 8x8 font, so add 8.
	bra	aputbreturn	* and exit, no further processing.
*
**************
* Y >= 400-8 or 200-8. 
* Alas, we must scroll entire screen up. Essentially, it's a matter
* of shifting (80 x 25) chars up one char.
* In mono, it's  (80 x 25 x 16 ) bytes up 16 bytes (16 x 80 for the line).
* In color, it's (80 x 25 x 8 x 2) bytes up 8 bytes (16 x 80 for the line).
* REMEMBER the confusing color mapping!
*  
* We must also blank the bottom line. It's worse than it sounds.
*
scroller: nop
*
* For 80 bytes across, shift up 16 bytes. Do this for 25 rows.
* For 160 bytes across, also shift up 16 bytes. Do this for 25 rows.
*
* Determine screen start (mono or color)
	movea.l	screenptr,a0	* screen's top left, from initfont
	movea.l	a0,a1		* and in a1; save it for a moment later.
* Determine 1 line down's starting address...
	adda.l	#$50*16,a1	* top left of 1 line down
* What's weird is that even though we have 2 bytes per displayed byte in
* color, since we only have half the data per color char (8x8 font),
* the memory allocation per char (or line) is the same. Lucky for us.
*
* A1 points to 1 line below. A0 points to current line.
* Hence copying (a1) to (a0) will "move" it up.
*
* Set up to do the copy upwards..use .longs for speed.
	move.l	#$1e00-1,d0	* counter of how many to move..=384x80=7e00
*				* bytes, or 1e00 longs.
*				* same for (200-8)  x 160 per line.
* and do the copy.
scrollit: move.l (a1)+,(a0)+
	dbf	d0,scrollit	* scroll them up..
*
* (We leave Y where it is, so next time through we scroll again.)
*
* The last line will containm a copy of the line above it; we need to
* blank it out.
*
* Clear bottom line.. Get bottom line's address:
	movea.l screenptr,a0	* as set up by initfont
* Now add offset to last line onscreen...
	adda.l	#$7800,a0	* bottom line's top left (384 x 80 bytes down)
*				* or 192 x 160 bytes down)
* # of bytes to clear .. 80 x 16 on monochrome, 160 x 16 on color..
	move.l	#340-1,d0	* counter = 16x80: perhaps add 1 more? 
*				* now 17x80  = 1360/4 per long  = 340 longs
* And store whites into it. (data = 0000 0000)
	moveq.l	#0,d1		* to-store in .. 0 = white space.
*
* We store out of d0 because anytime you can use a register, it's lots
* quicker.
*
* And here's where we zap it in
clearit: move.l d1,(a0)+	* clear out one long (white screen)
	dbf	d0,clearit
*
	bra	aputbreturn	* scrolling done, return, nothing else to do.
*****************
* Handle CR: 
* Just return our X coordinate to the left. This is real easy.
*
atdocr:	move.w	#1,atscrnx	* 1 to x.
	bra	aputbreturn
*****************
* Handle anything BUT  cr or lf: in other words, a character.
*
* Must copy the character font from the table in ROM to RAM locs.
*
atdochar: nop
*
* Determine copy-to location: screenptr + (80 (mono) or 160 (color)* atscrny) + 
* (atscrnx * 1 if mono, 2 if color since 2 words per pixel)
*
	move.l	screenptr,d1	* base of screen RAM into d1
*
* Calc screenptr + (80 or 160)  * y
* d1 = screenbase addr
 	clr.l	d2		* nothing in top of register for word fetch
* d2 = atscrny
	move.w	atscrny,d2	* get Y, (essentially, sign extended)
* d3 = # of bytes per row
	clr.l	d3		* clear upper d3
	move.w	#$50,d3		* get screen width into d3 (50)
	tst.w	colorflag
	beq	notrosebud
*	move.l	#$A0,d3		* color screen... 160 per line
	move.l	#$50,d3		* color screen... makes it work. Magic.
notrosebud: nop
* Multiply (# of bytes per line) * (number of lines down)
	mulu	d3,d2		* d2 has offset now (80 or 160 *y)
* Add in screenptr to get absolute address of this line
	add.l	d2,d1		* d1 has address of beginning of char's line
*				* now.
* Calc  + X if mono.
*
* Color is trickier than that.
*
* Color bitmap looks like this:
*
*  word 1     word2     word3     word4
* char1char2 nullnull char3char4 nullnull....
*   1    2    3   4     5   6     7   8
*
* Must write  1,2, 5,6, 9,10 13 14
*             1 2  3 4  5  6  7 8
*
* x-1:        0 1  2 3  4  5  6  7
* Hence, (x-1) * 2
*             0 2  4 6  8  10 12 14
* And if x-1 is even, add 1:
*             1 2  5 6  9  10 13  14
* 
* Then subtract one to get it to offset starting at 0. Otherwise we
* offset 1 byte into it, and get problems.
* 
*	      0 1  4 5  8  9  12  13
* .. etc
* Hence, 4*x to get to base, +1 or +2 to get to char.
*
* Entry: d1 has address of top left of current line. Calc d2, the byte offset
* on this current line.
*
	tst.w	colorflag
	beq	notpurple	* mono.
* Color processing: lots to do.
	add.l	d2,d1		* add the X coord again (for twice)
	clr.l	d2		* Okay, free up d2 now

	move.w	atscrnx,d2	* get x, into a long
	sub.l	#1,d2		* see above algorithm
	move.l	d2,d3		* save even flag in d3
	andi.l	#1,d3		* mask it off; 0 = even, 1 = odd in d3
	add.l	d2,d2		* (x-1) * 2
	tst.l	d3		* look for even/odd
	bne	ainteven	* 1,3, 5... etc
	add.l	#1,d2		* add the 1.
ainteven: nop
	sub.l	#1,d2		* widget factor
* d2 now has the offset to topleft of character. I'm confused, how about you?
	bra	moremore
****************
* Monochrome. 
notpurple: nop
* Monochrome. Much easier .. just add X to it.
	clr.l	d2
	move.w	atscrnx,d2
****************
* Anyway, add whatever d2 came out to be (the offset on this current line)
* to the line's absolute address hanging out in d1.
moremore: nop			
	add.l	d2,d1		* d1 now has address of top left of char
* And put into address registerm, because that's our destination loc.
	movea.l	d1,a1		* And now a1 has it (starting loc to copy to;
*				* upper left corner of character's byte.
*
* Calc copy-from location in Atari's ROMS
*
	move.l	monofontbase,d1	* base of fonts in ST ROM (set at beginning
*				* in initfonts; assume it, then change if
*				* we need to)
* If color, point at other one
*
	tst.w	colorflag
	beq	notbill
	move.l	colorfontbase,d1
	nop
notbill: nop
*
* Mask off d0 (remember him?), the ASCII character we are trying
* to plot, just for insurance. Then, index into the font table
* using him; that'll be the first byte of the character bitmap.
*
	andi.l	#$000000ff,d0	* mask d0 off completely
	add.l	d0,d1		* d1 points to base of character
	movea.l	d1,a0		* now a0 does
*
* Whew. Now, a0 points to the character's start in ROM, and a1
* points to where we want to copy him in screen memory. Sheesh.
*
* Only tricky thing now is how fonts are laid out in memory. There's
* 256 chars in all, and they store them:
*
* char 0 row 1
* char 1 row 1
* char 2 row 1
*  ...
* char 255 row 1
* char 0   row 2
* char 1   row 2
*
* Instead of how you'd think. So, we need to skip 256 bytes to find the
* next row of each character.
*
* Do copy of 16 bytes(mono) or 8 (color). (d2 will count). 
* Font layout is 1st row of
* all 256 chars, then 2nd row, then third.. so there's 256 bytes
* between each character row.
*
* So:   copy 1 byte,
*       add 256 to a0 (rom font pointer)
* 	add 80 or 160 to a1 (ram dest pointer)
*       and loop again. Do this 8 (color) or 16 (mono) times.
*
*
	move.l	#16-1,d2	* 16 bytes: mono. Assume it, change if needed.

	tst.w	colorflag
	beq	notlimekiller
	move.l	#8-1,d2		* 8 bytes: color
	nop
notlimekiller: nop

* The Actual Loop that copies the character onto the screen..
* Newer: Do both chars in a med rez, so it comes up white.
*
copyloop: nop
	move.b	(a0),(a1)	* copy 1 byte, rom to ram
	tst.w	colorflag
	beq	nosecond
	move.b	(a0),2(a1)	* copy it into echo character as well.(next wd)
* Assume mono shift to next line down...
nosecond: nop
	adda.l	#$50,a1		* shift to next line down in screen RAM (dest)
* and if we're in color, add the needed amount to get it right
	tst.w	colorflag	* if color, we have to shift 160, not 80
	beq	notmilo
	adda.l	#$50,a1		* so add another 80
notmilo: nop
* Then, shift down in ROM font...
	adda.l	#$100,a0	* shift to next byte of bit image (src)
* Around, around we go...
	dbf	d2,copyloop	* and do 16 total. rah rah.
*
* Okay, we have the char copied, now we gotta update X and split.
*
	add.w	#1,atscrnx	* 1 byte over..
* We haven't considered wrapping at 80th character, but we would just
* set X to 1 and then send an LF through this routine. Too much work.
*
* This is the exit point. Also handles cr/lf exits (remember them?)
*
* Unstack all registers, and split.
*
aputbret:	nop		* return entry if cr/lf (not char output)
*
	movem.l	atptrsave,d0-d7/a0-a7 * fix up registers (from printer save)
	rts
*
**********************
* Various dull font driver variables
*
monofontbase:	.dc.l	0			* base of ROM 8x16 font
colorfontbase:  .dc.l	0			* base of ROM 8x8 font
colorflag:	.dc.w	0			* 0=mono, ffff=color
screenptr:	.dc.l	0			* base of video RAM
atscrnx:	.dc.w	0			* x loc onscreen (0-79)
atscrny:	.dc.w	0			* y loc onscreen (0-400/200)0
atptrsave:	.dc.l	0,1,2,3,4,5,6,7,0,1,2,3,4,5,6,7	* saves d0-d7/a0-a7
		.dc.l	6			* for fun

********************* end aputc ****************************************
